#include <stddef.h>

#include "CommandPost.h"

#include "../dvview.h"


int32_t CommandPost_Jog_data[4] = {
    2, 1, 3, 0
};

trans_result_t CommandPost_Jog_trans(int32_t raw, int32_t prev) {
    trans_result_t result;

    result.data = CommandPost_Jog_data[raw];
    result.diff = result.data - prev;
    if (result.diff == 3) {
	result.diff = -1;
    } else if (result.diff == -3) {
	result.diff = 1;
    }
    result.action = ACT_NONE;
    if (result.data == 0) {
	if (0 < result.diff) {
	    result.action = ACT_NEXT;
	} else if (result.diff < 0) {
	    result.action = ACT_PREV;
	}
    }
    return result;
}


int32_t CommandPost_Shuttle_data[8] = {
    -2, -3, -1, -4, 2, 3, 1, 0
};

int CommandPost_Shuttle_action[9] = {
    ACT_BACKx2, ACT_BACKx1, ACT_BACKs5, ACT_BACKs10,
    ACT_PAUSE,
    ACT_PLAYs10, ACT_PLAYs5, ACT_PLAYx1, ACT_PLAYx2
};

trans_result_t CommandPost_Shuttle_trans(int32_t raw, int32_t prev) {
    trans_result_t result;

    result.data = CommandPost_Shuttle_data[raw];

    if (result.data == 0 && prev == 3) {
	result.data = 4;
    }
    result.action = ACT_NONE;
    if ((result.diff = result.data - prev) != 0) {
	result.action = CommandPost_Shuttle_action[result.data + 4];
    }
    return result;
}


struct ctrl_bind CommandPost_bind[] = {
    { "Button_8",   "PLAY",	ACT_PLAY,   ACT_NONE,	NULL },
    { "Button_1",   "-X4",	ACT_BACKx4, ACT_NONE,	NULL },
    { "Button_2",   "-X8",	ACT_BACKx8, ACT_NONE,	NULL },
    { "Button_7",   "X4",	ACT_PLAYx4, ACT_NONE,	NULL },
    { "Button_6",   "X8",	ACT_PLAYx8, ACT_NONE,	NULL },
    { "Wheel",	    "JOG",	ACT_NONE,   ACT_NONE,	CommandPost_Jog_trans },
    { "Dial",	    "SHUTTLE",	ACT_NONE,   ACT_NONE,	CommandPost_Shuttle_trans },
    { "Button_12",  "Open",	ACT_OPEN,   ACT_NONE,	NULL },
    { "Button_16",  "Quit",	ACT_QUIT,   ACT_NONE,	NULL },
    { NULL,	    NULL,	NULL,	    NULL,	NULL },
};

struct controller CommandPost_def = {
    "CommandPost",
    CommandPost_bind
};
